uniform mat4 uMVPMatrix;

const float cUVTZScaleFactor = 1.0 / 255.0;
const float cOffTheScreenParticlePosition = 50000.0;

attribute vec2 aParticleVertex;
attribute vec2 aParticlePosition;

attribute vec2 aParticleTextureCoordinate;
attribute vec4 aUVTA;

varying vec2 vParticleTextureCoordinate;
varying vec2 vPaletteTextureCoordinate;
varying lowp float vAlpha;

void main() {
	vParticleTextureCoordinate = aParticleTextureCoordinate;
	vPaletteTextureCoordinate = vec2(aUVTA.z * cUVTZScaleFactor, 0.0);
    vAlpha = aUVTA.w;

	vec2 particlePosition = aParticlePosition;
	if (aUVTA.z < 0.0) {
        particlePosition.x = cOffTheScreenParticlePosition;
        particlePosition.y = cOffTheScreenParticlePosition;
	}

    float angle = atan(aUVTA.x, aUVTA.y);
    mat2 rotationMatrix = mat2(cos(angle), -sin(angle), sin(angle), cos(angle)); // columns are passed

    vec2 rotatedParticleVertex = rotationMatrix * aParticleVertex;

    vec4 particleVertex =  vec4(particlePosition.x + rotatedParticleVertex.x, particlePosition.y + rotatedParticleVertex.y, 0.0, 1.0);

    gl_Position = uMVPMatrix * particleVertex;
}